mob
	Login()
		..()
		if(!isnull(global.announcements))
			src<<browse("[global.announcements]","window=Server Announcements;size=540x480")
	Admin
		verb
			CheckLogs()
				set category = "Admin"
				var/list/lcheck = list("Edit","Suggestions","Bugs","Server Announcements","Other")
				var/input = input("Which Logs do you wish to view?","Log Check") in lcheck
				alert("If your view is not 800x600+ You will have to alt+f4 close the window.")
				switch(input)
					if("Other")
						if(alert("View or Download?","Other Logs View - D/L","View","Download")=="View")
							if(alert("Today or Date?","Other Logs View","Today","Date")=="Date")
								var/mn = input("What Month?","Month") in list("January","February",\
								"March","April","May","June","July","August",\
								"September","October","November","December")
								var/dy = input("What Day - Format '01' or '20'","Day") as text
								var/txtfile = file("lgs/other/[mn]/[dy].htm")
								if(fexists(txtfile))
									var/savefile/S = new()
									S.ImportText("/",txtfile)
									var/filecheck
									S["other"] >> filecheck
									usr<<browse("[filecheck]","window=Other Logs;size=800x600")
								else
									alert("No logs for [mn]/[dy].")
							else
								usr<<browse("[global.olog]","window=Other Logs;size=800x600")
						else
							var/mn = input("What Month?","Month") in list("January","February",\
							"March","April","May","June","July","August",\
							"September","October","November","December")
							var/dy = input("What Day - Format '01' or '20'","Day") as text
							var/txtfile = file("lgs/other/[mn]/[dy].htm")
							if(fexists(txtfile))
								usr << ftp(txtfile)
							else
								alert("No savefile for [mn]/[dy].")
					if("Edit")
						if(alert("View or Download?","Edit Logs View - D/L","View","Download")=="View")
							if(alert("Today or Date?","Edit Logs View","Today","Date")=="Date")
								var/mn = input("What Month?","Month") in list("January","February",\
								"March","April","May","June","July","August",\
								"September","October","November","December")
								var/dy = input("What Day - Format '01' or '20'","Day") as text
								var/txtfile = file("lgs/edit/[mn]/[dy].htm")
								if(fexists(txtfile))
									var/savefile/S = new()
									S.ImportText("/",txtfile)
									var/filecheck
									S["edit"] >> filecheck
									usr<<browse("[filecheck]","window=Edit Logs;size=800x600")
								else
									alert("No logs for [mn]/[dy].")
							else
								usr<<browse("[global.editlog]","window=Edit Logs;size=800x600")
						else
							var/mn = input("What Month?","Month") in list("January","February",\
							"March","April","May","June","July","August",\
							"September","October","November","December")
							var/dy = input("What Day - Format '01' or '20'","Day") as text
							var/txtfile = file("lgs/edit/[mn]/[dy].htm")
							if(fexists(txtfile))
								usr << ftp(txtfile)
							else
								alert("No savefile for [mn]/[dy].")
					if("Suggestions")
						switch(alert("View/Download/Edit?","Suggestion Logs View - D/L - Edit","View","Download","Edit"))
							if("View")
								usr<<browse("[global.sugs]","window=Suggestions;size=800x600")
							if("Download")
								var/sugfile = file("lgs/sugs.htm")
								if(fexists(sugfile))
									alert("No Suggestions logged.")
								else
									usr << ftp(sugfile)
							if("Edit")
								global.sugs = input(usr ,"Change Announcements","Change Announcements",global.sugs) as message
								var/savefile/F = new()
								var/txtfile = file("lgs/sugs.htm")
								F["sugs"] << global.sugs
								fdel(txtfile)
								F.ExportText("/",txtfile)
					if("Bugs")
						switch(alert("View/Download/Edit?","Bugs Logs View - D/L - Edit","View","Download","Edit"))
							if("View")
								usr<<browse("[global.bugs]","window=Bug Logs;size=800x600")
							if("Download")
								var/bugfile = file("lgs/bugs.htm")
								if(fexists(bugfile))
									alert("No Bugs logged.")
								else
									usr << ftp(bugfile)
							if("Edit")
								global.bugs = input(usr ,"Change Announcements","Change Announcements",global.bugs) as message
								var/savefile/F = new()
								var/txtfile = file("lgs/bugs.htm")
								F["bugs"] << global.bugs
								fdel(txtfile)
								F.ExportText("/",txtfile)
					if("Server Announcements")
						switch(alert("View/Download/Edit?","Server Announcements View - D/L","View","Download"))
							if("View")
								usr<<browse("[global.announcements]","window=Bug Logs;size=800x600")
							if("Download")
								var/announcements = file("lgs/announcements.htm")
								if(isnull(announcements))
									alert("No Announcements logged.")
								else
									usr << ftp(announcements)
var
	sugs=""
	bugs=""
	requests = ""
	editlog=""
	olog=""
	boottime
	announcements
world
	New()
		..()
		boottime = time2text(world.realtime,"DD")
		world << "<i><font color = red>Initiating world procedures.</i>"
//Other Logs
		world << "<i><font color = red>Logs Load...</i>"
		var/savefile/S = new
		var/mn=time2text(world.realtime,"MM")
		mn=d2t(mn)
		var/dy=time2text(world.realtime,"DD")
		var/txtfile = file("lgs/other/[mn]/[dy].htm")
		S.ImportText("/",txtfile)
		if(!fexists("lgs/other/[mn]/[dy].htm"))
			global.olog += "<STYLE>BODY{background: black; color: white}</STYLE><H1><font color = teal><center>Other Logs</H1> <font color = white>([mn]/[dy]) </center></font><br>"
			savolog()
		else
			S["other"] >> global.olog
//Edit Logs
		mn=time2text(world.realtime,"MM")
		mn=d2t(mn)
		dy=time2text(world.realtime,"DD")
		txtfile = file("lgs/edit/[mn]/[dy].htm")
		S.ImportText("/",txtfile)
		if(!fexists("lgs/edit/[mn]/[dy].htm"))
			global.editlog += "<STYLE>BODY{background: black; color: white}</STYLE><H1><font color = teal><center>Edit Logs</H1> <font color = white>([mn]/[dy]) </center></font><br>"
			savelog()
		else
			S["edit"] >> global.editlog
//Suggestion Logs
		txtfile = file("lgs/sugs.htm")
		S.ImportText("/",txtfile)
		if(!fexists("lgs/sugs.htm"))
			global.sugs += "<STYLE>BODY{background: black; color: white}</STYLE><H1><font color = teal><center>Suggestion Logs</center></font></H1><br>"
			txtfile = file("lgs/sugs.htm")
			S["sugs"] << global.sugs
			fdel(txtfile)
			S.ExportText("/",txtfile)
		else
			S["sugs"] >> global.sugs
//Bug Logs
		txtfile = file("lgs/bugs.htm")
		S.ImportText("/",txtfile)
		if(!fexists("lgs/bugs.htm"))
			global.bugs += "<STYLE>BODY{background: black; color: white}</STYLE><H1><font color = teal><center>Bug Logs</center></font></H1><br>"
			txtfile = file("lgs/bugs.htm")
			S["bugs"] << global.bugs
			fdel(txtfile)
			S.ExportText("/",txtfile)
		else
			S["bugs"] >> global.bugs
//Server Announcements
		txtfile = file("lgs/announcements.htm")
		S.ImportText("/",txtfile)
		if(isnull(S))
		else
			S["announcements"] >> global.announcements

proc
	bugadd(T,M,K)
		global.bugs += {"<LI> [html_encode("[M]([K])[T]")]</LI><br>"}
		var/savefile/F = new()
		var/txtfile = file("lgs/bugs.htm")
		F["bugs"] << global.bugs
		fdel(txtfile)
		F.ExportText("/",txtfile)
	sugadd(T,M,K)
		global.sugs += {"<LI> [html_encode("[M]([K])[T]")]</LI><br>"}
		var/savefile/F = new()
		var/txtfile = file("lgs/sugs.htm")
		F["sugs"] << global.sugs
		fdel(txtfile)
		F.ExportText("/",txtfile)
	elogadd(T)
		checkdate()
		var/time = world.timeofday
		var/hours = round(time / 3600)
		time %= 3600
		var/minutes = round(time / 60)
		time %= 60
		global.editlog += "{[hours]:[minutes]}[T]<br>"
		savelog()
	ologadd(T)
		checkdate()
		var/time = world.timeofday
		var/hours = round(time / 3600)
		time %= 3600
		var/minutes = round(time / 60)
		time %= 60
		global.olog += "{[hours]:[minutes]}[T]<br>"
		savolog()
	savolog()
		var/savefile/F = new()
		var/mn=time2text(world.realtime,"MM")
		mn=d2t(mn)
		var/dy=time2text(world.realtime,"DD")
		var/txtfile = file("lgs/other/[mn]/[dy].htm")
		F["other"] << global.olog
		fdel(txtfile)
		F.ExportText("/",txtfile)
	savelog()
		var/savefile/F = new()
		var/mn=time2text(world.realtime,"MM")
		mn=d2t(mn)
		var/dy=time2text(world.realtime,"DD")
		var/txtfile = file("lgs/edit/[mn]/[dy].htm")
		F["edit"] << global.editlog
		fdel(txtfile)
		F.ExportText("/",txtfile)
	checkdate()
		if(time2text(world.realtime,"DD") <> "[global.boottime]")
			global.boottime = time2text(world.realtime,"DD")
			var/mn=time2text(world.realtime,"MM")
			mn=d2t(mn)
			var/dy=time2text(world.realtime,"DD")
			global.olog = ""
			global.editlog = ""
			global.editlog = "<STYLE>BODY{background: black; color: white}</STYLE><H1><font color = teal><center>Edit Logs</H1> <font color = white>([mn]/[dy]) </center></font><br>"
			global.olog = "<STYLE>BODY{background: black; color: white}</STYLE><H1><font color = teal><center>Other Logs</H1> <font color = white>([mn]/[dy]) </center></font><br>"
	d2t(nm)
		if(nm == "01") return "January"
		if(nm == "02") return "February"
		if(nm == "03") return "March"
		if(nm == "04") return "April"
		if(nm == "05") return "May"
		if(nm == "06") return "June"
		if(nm == "07") return "July"
		if(nm == "08") return "August"
		if(nm == "09") return "September"
		if(nm == "10") return "October"
		if(nm == "11") return "November"
		if(nm == "12") return "December"