
mob
	PC
	Admin
		verb
			AddAdmin()
				set category = "Admin"
				if(alert("Manually add, or select?","Manual/Select","Manual","Select")=="Select")
					var/mob/M = input("Please select a new admin") as mob in world
					if(M.admin || M.name==src.name)
						src << "They already are an Admin"
					else
						Admin.Add(M.key)

						world << "[M.name] Has just been promoted to Admin Status"
						M.admin = 1
						elogadd("[src.name] has just promototed [M.name]")
						AdminSave()
				else
					var/akey = input("Type the exact key of the person you wish to add.") as text
					Admin.Add(akey)
					AdminSave()

			RemoveAdmin(var/X in Admin|null)
				set category = "Admin"
				if(X == "N1ghtW1ng" || X == "N1ghtW1ng") src << "You can not demote the owner!"
				if(alert("Manually remove, or select?","Manual/Select","Manual","Select")=="Select")
					var/mob/M = input("Please select the old admin") as mob in world
					if(!M.admin || M.name==src.name)
						src << "They aren't an Admin"
					else
						Admin.Remove(M.key)

						world << "[M.name] Has just been removed from his Admin Status"
						M.admin = 0
						elogadd("[src.name] has just removed [M.name]")
						AdminSave()
				else
					var/rkey = input("Type the exact key of the person you wish to remove.") as text
					Admin.Remove(rkey)
					AdminSave()

			Boot(mob/PC/M)

				set category = "Admin"
				input("Who do you wish to boot?",M.name) in typesof(/mob/PC)
				var/reason = input("Why do you wish to boot [M.name] please use full details for it is logged?",M.name) as text
				if(reason == "")
					src << "You need a valid reason not null"
					return

				if(M)
					if(!M.admin)
						//Save()
						world << "[M.name] was booted by [src.name] for [reason]"
						ologadd("[src.name] booted [M] for [reason]")
						del(M)
					else
						alert("You can't boot another Admin")


			Reboot()
				set category = "Admin"
				world << "<font size = 1><font color = blue> 10 seconds till reboot";sleep(50)
				world << "<font size = 1><font color = blue> 5 seconds till reboot";sleep(20)
				world << "<font size = 1><font color = blue> 3 seconds till reboot";sleep(10)
				world << "<font size = 1><font color = blue> 2 seconds till reboot";sleep(10)
				world << "<font size = 1><font color = blue> 1 seconds till reboot";world.Reboot()

				ologadd("[src.name] rebooted the server")
			Browser()
				set category = "Admin"
				var/title = input("What do you want the title of the browser to be?") as message
				var/blah = input("What do you want the message in the browser to be?") as message
				var/Title1={"
				<HTML>
				<BODY bgcolor=blue text=red>
				<center><h1>[title]</h1></center>
				<br><br>
				[blah]
				</BODY>
				</HTML>"}
				ABrows = 1
				world << browse(Title1)
				ologadd("[src.name] altered the browser to read [title]<br><br>[blah]")

			Display_IP_Address(mob/PC/M as mob in world)
				set category = "Admin"
				if (!M.client) return
				src << "[M.key]'s IP address is: [M.client.address]"
				ologadd("[src.name] looked at [M.key]'s IP and it was [M.client.address]")



			Announce(T as text)
				set category = "Admin"
				world << "<font color = navy>---<b><u>Announcement by GM [src.name]---</b></u><br><br><b><font color = blue>[T]"
				ologadd("[src.name] made an announcement:[T]")

			Rename(mob/PC/M as mob in world,NewName as text)
				set category = "Admin"
				elogadd("[src.name] renamed [M.name] to [NewName]")
				M.name = NewName


			Kill(mob/PC/M as mob in world)
				set category ="Admin"
				M.hp = 0
				M.DeathCheck()
				world << "Uber Admin [src.name] killed [M.name]"
				ologadd("[src.name] Admin killed [M.name]")




			LockMove(mob/PC/M)
				set category ="Admin"
				input("Who do you wish to Lock or Unlock from their place",src.name) in typesof (/mob/PC)
				if(M.name !=src.key)
					if(M.movelock)

						M.movelock = 0
						elogadd("[src.name] unlocked [M.name] in his place")
					else
						M.movelock = 1
						elogadd("[src.name] locked [M.name] in his place")
				else
					src << "You can not lock your self in place...it is kind of redundant =P"


			Admin_Teleport(mob/M as mob in world)
				set category ="Admin"
				src.loc = locate(M.x,M.y,M.z)
				ologadd("[src.name] teleported to [M.name]") //some people might want to take this one off seeing as it is used alot


			Admin_Warp(mob/M as mob in world)
				var/A = input(src,"What X coord. do you wish to send [M] to? If null [M] will be sent to (1,y,z)","X Coord.") as num | null
				if(A == 0) A = 1
				var/B = input(src,"What Y coord. do you wish to send [M] to? If null [M] will be sent to (x,1,z)","Y Coord.") as num | null
				if(B == 0) B = 1
				var/C = input(src,"What Z coord. do you wish to send [M] to? If null [M] will be sent to (x,y,1)","Z Coord.") as num |null
				if(C == 0) C = 1
				M.loc = locate(A,B,C)

			Admin_Summon()
				set category ="Admin"
				var/mob/M = input("Who do you wish to summon from their place") as mob
				if(M.name != src.name)
					M.oldx = M.x
					M.oldy = M.y
					M.oldz = M.z
					M.loc = locate(src.x,src.y,src.z)
					ologadd("[src.name] summoned [M.name]") //some people might want to take this one off seeing as it is used alot

			Admin_UnSummon()
				set category ="Admin"
				var/mob/M = input("Who do you wish to unsummon and send them back to their original place") as mob
				if(M.name != src.name)
					if(oldx || oldy || oldz)
						M.x = M.oldx
						M.y = M.oldy
						M.z = M.oldz
						M.loc = locate(M.x,M.y,M.z)
						ologadd("[src.name] unsummoned [M.name] to his original place") //some people might want to take this one off seeing as it is used alot
					else
						src << "[M.name] has no original place"
				else
					src << "You can't unsummon your self"


			Change_World_Name(Name as text)
				set category ="Admin"
				world.name = Name
				elogadd("[src.name] changed the world name to [Name]")


			Change_World_Status(Status as text)
				set category ="Admin"
				world.status = Status
				elogadd("[src.name] changed the world status to [Status]")


			Del_Object(obj/O in view(6)) // Change the 6 to the size of your window
				del(O) //didn't log this one, because there wasn't really a reason

			ChangeAnnouncements()
				global.announcements = input(usr ,"Change Announcements","Change Announcements",global.announcements) as message
				var/savefile/F = new()
				var/txtfile = file("lgs/announcements.htm")
				F["announcements"] << global.announcements
				fdel(txtfile)
				F.ExportText("/",txtfile)


			AddWatchee(key as text)
				onwatch.Add(key)
				var/savefile/F = new("Watched.sav")
				F["Watched.sav"] = global.onwatch


			RemoveWatchee()
				if(!length(onwatch))
					alert("No keys to be removed.")
					return
				var/keyrem = input("What key do you wish to remove?") in onwatch
				if(key == "Guest") return
				onwatch.Remove(keyrem)
				src << "[keyrem] removed."
				var/savefile/F = new("Watched.sav")
				F["Watched.sav"] = global.onwatch

			Create()
				set category = "Admin"
				switch(input("What type do you wish to create:") in list ("/mob","/obj","/turf"))
					if("/mob")
						var/G = input("What do you wish to create") in typesof(/mob)
						new G(src.x,src.y,src.z)
						elogadd("[src.name] created [G]")
					if("/obj")
						var/G = input("What do you wish to create") in typesof(/obj)
						new G(src.x,src.y,src.z)
						elogadd("[src.name] created [G]")
					if("/turf")
						var/G = input("What do you wish to create") in typesof(/mob)
						new G(src.x,src.y,src.z)
						elogadd("[src.name] created [G]")

			Mute(mob/PC/M)
				set category = "Admin"
				input("Who do you wish to Mute/Unmute?",M.name) in typesof (/mob/PC)
				if(!M.Mute)
					M.Mute = 1
				else
					M.Mute = 0


			Ban(mob/M as mob in world)
				set desc="(player) Ban a player"
				if (alert(src,"Do you really want to ban [M]?","Really ban?","Ban","Cancel")=="Ban")
					crban_fullban(M)

			Baniprange(range as text)
				var/banned=crban_iprange(range)
				if (banned)
					src << "Successfully banned IP range: [banned]"
				else
					src << "Not a valid IP range: [range]"

			Unban(key as text)
				set desc="(key) Unban the specified key"
				crban_unban(key)

			Display_ip_address(mob/M as mob in world)
				if (!M.client) return
				src << "[M.key]'s IP address is: '[M.client.address]'"




//Stuff Needed for some of the above verbs

var/list/onwatch = list()

client/New()
	.=..()
	world << "<b>[src] logs in</b>"

client/Del()
	if (!crban_isbanned(src))
		world << "<b>[src] logs out</b>"
	.=..()

client/Move()
	if(!mob.movelock) return
	else ..()




mob
	verb
		Say(T as text)
			if(!Mute)
				world << "[src.name] says : [T]"
				if(onwatch.Find(usr.key))
					ologadd("[src.name] says : [T]")
			else
				src << "You are muted, please wait till you are unmuted"

		SubmitBug(msg as message)
			bugadd(msg,usr.name,usr.key)


		SubmitSuggestion(msg as message)
			sugadd(msg,usr.name,usr.key)



world/New()
	..()
	if(fexists("Watched.sav"))
		var/savefile/F = new("Watched.sav")
		global.onwatch = F["Watched.sav"]
	else
		global.onwatch += list("Guest")
		var/savefile/F = new("Watched.sav")
		F["Watched.sav"] = global.onwatch

world
	New()
		..()
		if(fexists("Admin.sav"))
			var/savefile/F = new ("Admin.sav")
			F["Admin"] >> Admin
		else
			Admin = list("N1ghtW1ng")



proc
	AdminSave()
		var/savefile/F = new ("Admin.sav")
		F["Admin"] << Admin


var/list/Admin = list()

mob/var
	admin;ABrows;movelock = 1;oldx;oldy;oldz;Mute
mob
	proc
		AdminCheck(mob/M)
			if(Admin.Find(M.key))
				admin = 1
				M.verbs += typesof(/mob/Admin/verb)
	Login()
		AdminCheck(src)
		..()






